function [c,d,f,g,kappas1,kappas2]=alloc(kappa,a,b,L,m,options1,options2)
    
lagrange_multiplier_guess=1;
kappa1 = 0.3*kappa;
kappa2 = 0.7*kappa;
    
sigma = fsolve(@IIDsignals,a(1),options1,a,kappa1);
    if sigma < 0; sigma = -sigma; end;
    M = zeros(m,m-1+L); N = zeros(m,m-1+L);
    for j = 1:m;
        M(j,j:j-1+length(a)) = a'; 
        N(j,j:j-1+length(sigma)) = sigma'; 
    end;
    lambda_vec = [a; zeros(m-1+L-length(a),1)];
    c_guessed = (((M*M'+N*N')\(M*lambda_vec))'*M)'; 
    d_guessed = (((M*M'+N*N')\(M*lambda_vec))'*N)'; 
    c_guessed = c_guessed(1:L);
    d_guessed = d_guessed(1:L); 
    
    sigma = fsolve(@IIDsignals,b(1),options1,b,kappa2);
    if sigma < 0; sigma = -sigma; end;
    M = zeros(m,m-1+L); N = zeros(m,m-1+L);
    for j = 1:m;
        M(j,j:j-1+length(b)) = b'; 
        N(j,j:j-1+length(sigma)) = sigma'; 
    end;
    lambda_vec = [b; zeros(m-1+L-length(b),1)];
    f_guessed = (((M*M'+N*N')\(M*lambda_vec))'*M)';
    g_guessed = (((M*M'+N*N')\(M*lambda_vec))'*N)'; 
    f_guessed = f_guessed(1:L); 
    g_guessed = g_guessed(1:L); 
    
    yt0 = [c_guessed; d_guessed; f_guessed; g_guessed; kappa1; kappa2; lagrange_multiplier_guess];
    
    yt = fsolve(@RI_fixedpoint,yt0,options2,a,b,m,L,kappa);
    c = yt(1:L);
    d = yt(L+1:2*L);
    f = yt(2*L+1:3*L);
    g = yt(3*L+1:4*L);
    kappas1 = yt(end-2);
    kappas2 = yt(end-1);
