function integra = infoflow_integral(omega,x,y,n) 

for j = 1:n;
    CC(j,:) = x(j,:).*(cos((j-1)*omega) + i*sin((j-1)*omega)); 
    FF(j,:) = y(j,:).*(cos((j-1)*omega) + i*sin((j-1)*omega));
end;
CC = sum(CC); FF = sum(FF);
CCmin = conj(CC); FFmin = conj(FF);
coherence = (CC.*CCmin)./(CC.*CCmin + FF.*FFmin);
integra = log(1 - coherence);