function [xc,xf] = detrend1(y,q)

vague = 1e+4;  

f = zeros(2,2);
f(1,1) = 2;
f(1,2) = -1;
f(2,1) = 1;
x = zeros(2,1);
p = vague*ones(2,2);
p(1,1) = vague+q;
xf = zeros(size(y,1),1);

for i = 1:size(y,1);
    x=f*x;              
    p=f*p*f';
    p(1,1)=p(1,1) + q;  
    if isnan(y(i)) == 0
        h=p(1,1)+1;         
        e=y(i)-x(1);        
        k=p(:,1)/h;         
        x=x+k*e;            
        p=p-(k*p(1,:));     
    end
    xf(i)=x(1);
end
xc=y-xf;
