% This program collects and combines simulation results and produce graphs

% 06/24/2016 by Fang Zhang

clear all;
close all;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Load Data
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

load('simulresult1');
ave_k_1=ave_k;
ave_ka_1=ave_ka;
ave_ks_1=ave_ks;
ave_mupost_1=ave_mupost;
ave_muprior_1=ave_muprior;
kappa_1=kappa;
kappaA_1=kappaA;
kappaS_1=kappaS;

infocost_1=(kappaA+kappaS)*phi; 
p_A=zeros(90,20,50);p_S=zeros(90,20,50);
p_A(1:89,:,:)=pA(:,1:20,1:50); p_S(1:89,:,:)=pS(:,1:20,1:50);
ploss_1=zeros(90,20,50);
for i=1:20
    for n=1:50
        for t=1:90
            ploss_1(t,i,n)=(p_diamA(t,n)-squeeze(p_A(t,i,n))).^2+(p_diamS(t,n)-squeeze(p_S(t,i,n))).^2;
        end
    end
end
loss_1=ploss_1+infocost_1;
ave_loss_1=mean(mean(loss_1,2),3);
ave_ploss_1=mean(mean(ploss_1,2),3);
ave_infocost_1=mean(mean(infocost_1,2),3);
        

load('simulresult2');
ave_k_2=ave_k;
ave_ka_2=ave_ka;
ave_ks_2=ave_ks;
ave_mupost_2=ave_mupost;
ave_muprior_2=ave_muprior;
kappa_2=kappa;
kappaA_2=kappaA;
kappaS_2=kappaS;

infocost_2=(kappaA+kappaS)*phi; 
p_A=zeros(90,20,50);p_S=zeros(90,20,50);
p_A(1:89,:,:)=pA(:,1:20,1:50); p_S(1:89,:,:)=pS(:,1:20,1:50);
ploss_2=zeros(90,20,50);
for i=1:20
    for n=1:50
        for t=1:90
            ploss_2(t,i,n)=(p_diamA(t,n)-squeeze(p_A(t,i,n))).^2+(p_diamS(t,n)-squeeze(p_S(t,i,n))).^2;
        end
    end
end
loss_2=ploss_2+infocost_2;
ave_loss_2=mean(mean(loss_2,2),3);
ave_ploss_2=mean(mean(ploss_2,2),3);
ave_infocost_2=mean(mean(infocost_2,2),3);

load('simulresult3');
ave_k_3=ave_k;
ave_ka_3=ave_ka;
ave_ks_3=ave_ks;
ave_mupost_3=ave_mupost;
ave_muprior_3=ave_muprior;
kappa_3=kappa;
kappaA_3=kappaA;
kappaS_3=kappaS;

infocost_3=(kappaA+kappaS)*phi; 
p_A=zeros(90,20,50);p_S=zeros(90,20,50);
p_A(1:89,:,:)=pA(:,1:20,1:50); p_S(1:89,:,:)=pS(:,1:20,1:50);
ploss_3=zeros(90,20,50);
for i=1:20
    for n=1:50
        for t=1:90
            ploss_3(t,i,n)=(p_diamA(t,n)-squeeze(p_A(t,i,n))).^2+(p_diamS(t,n)-squeeze(p_S(t,i,n))).^2;
        end
    end
end
loss_3=ploss_3+infocost_3;
ave_loss_3=mean(mean(loss_3,2),3);
ave_ploss_3=mean(mean(ploss_3,2),3);
ave_infocost_3=mean(mean(infocost_3,2),3);


load('simulresult4');
ave_k_4=ave_k;
ave_ka_4=ave_ka;
ave_ks_4=ave_ks;
ave_mupost_4=ave_mupost;
ave_muprior_4=ave_muprior;
kappa_4=kappa;
kappaA_4=kappaA;
kappaS_4=kappaS;

infocost_4=(kappaA+kappaS)*phi; 
p_A=zeros(90,20,50);p_S=zeros(90,20,50);
p_A(1:89,:,:)=pA(:,1:20,1:50); p_S(1:89,:,:)=pS(:,1:20,1:50);
ploss_4=zeros(90,20,50);
for i=1:20
    for n=1:50
        for t=1:90
            ploss_4(t,i,n)=(p_diamA(t,n)-squeeze(p_A(t,i,n))).^2+(p_diamS(t,n)-squeeze(p_S(t,i,n))).^2;
        end
    end
end
loss_4=ploss_4+infocost_4;
ave_loss_4=mean(mean(loss_4,2),3);
ave_ploss_4=mean(mean(ploss_4,2),3);
ave_infocost_4=mean(mean(infocost_4,2),3);

load('simulresult5');
ave_k_5=ave_k;
ave_ka_5=ave_ka;
ave_ks_5=ave_ks;
ave_mupost_5=ave_mupost;
ave_muprior_5=ave_muprior;
kappa_5=kappa;
kappaA_5=kappaA;
kappaS_5=kappaS;

infocost_5=(kappaA+kappaS)*phi; 
p_A=zeros(90,20,50);p_S=zeros(90,20,50);
p_A(1:89,:,:)=pA(:,1:20,1:50); p_S(1:89,:,:)=pS(:,1:20,1:50);
ploss_5=zeros(90,20,50);
for i=1:20
    for n=1:50
        for t=1:90
            ploss_5(t,i,n)=(p_diamA(t,n)-squeeze(p_A(t,i,n))).^2+(p_diamS(t,n)-squeeze(p_S(t,i,n))).^2;
        end
    end
end
loss_5=ploss_5+infocost_5;
ave_loss_5=mean(mean(loss_5,2),3);
ave_ploss_5=mean(mean(ploss_5,2),3);
ave_infocost_5=mean(mean(infocost_5,2),3);

load('simulresult6');
ave_k_6=ave_k;
ave_ka_6=ave_ka;
ave_ks_6=ave_ks;
ave_mupost_6=ave_mupost;
ave_muprior_6=ave_muprior;
kappa_6=kappa;
kappaA_6=kappaA;
kappaS_6=kappaS;

infocost_6=(kappaA+kappaS)*phi; 
p_A=zeros(90,20,50);p_S=zeros(90,20,50);
p_A(1:89,:,:)=pA(:,1:20,1:50); p_S(1:89,:,:)=pS(:,1:20,1:50);
ploss_6=zeros(90,20,50);
for i=1:20
    for n=1:50
        for t=1:90
            ploss_6(t,i,n)=(p_diamA(t,n)-squeeze(p_A(t,i,n))).^2+(p_diamS(t,n)-squeeze(p_S(t,i,n))).^2;
        end
    end
end
loss_6=ploss_6+infocost_6;
ave_loss_6=mean(mean(loss_6,2),3);
ave_ploss_6=mean(mean(ploss_6,2),3);
ave_infocost_6=mean(mean(infocost_6,2),3);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Compile Results
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

kappa_8=cat(3,kappa_1,kappa_2);
kappa_9=cat(3,kappa_3,kappa_4);
kappa_10=cat(3,kappa_5,kappa_6);
kappa=[kappa_8 kappa_9 kappa_10]; 

kappaA_8=cat(3,kappaA_1,kappaA_2);
kappaA_9=cat(3,kappaA_3,kappaA_4);
kappaA_10=cat(3,kappaA_5,kappaA_6);
kappaA=[kappaA_8 kappaA_9 kappaA_10]; 

kappaS_8=cat(3,kappaS_1,kappaS_2);
kappaS_9=cat(3,kappaS_3,kappaS_4);
kappaS_10=cat(3,kappaS_5,kappaS_6);
kappaS=[kappaS_8 kappaS_9 kappaS_10]; 

ave_k= (ave_k_1+ave_k_2+ave_k_3+ave_k_4+ave_k_5+ave_k_6)/6;
ave_ka= (ave_ka_1+ave_ka_2+ave_ka_3+ave_ka_4+ave_ka_5+ave_ka_6)/6;
ave_ks= (ave_ks_1+ave_ks_2+ave_ks_3+ave_ks_4+ave_ks_5+ave_ks_6)/6;

ave_mupost= (ave_mupost_1+ave_mupost_2+ave_mupost_3+ave_mupost_4+ave_mupost_5+ave_mupost_6)/6;
ave_muprior= (ave_muprior_1+ave_muprior_2+ave_muprior_3+ave_muprior_4+ave_muprior_5+ave_muprior_6)/6;

ave_infocost=(ave_infocost_1+ave_infocost_2+ave_infocost_3+ave_infocost_4+ave_infocost_5+ave_infocost_6)/6;
ave_ploss=(ave_ploss_1+ave_ploss_2+ave_ploss_3+ave_ploss_4+ave_ploss_5+ave_ploss_6)/6;
ave_loss=ave_ploss+ave_infocost;
ave_infocost=ave_infocost(6:end-1);
ave_ploss=ave_ploss(6:end-1);
ave_loss=ave_loss(6:end-1);

figure()

plotk(recindexplot)= max(ave_k)+0.2;
plotk(expindexplot)= min(ave_k)-0.2;
plotkas(recindexplot)= max(ave_ks)+0.5;
plotkas(expindexplot)= min(ave_ka)-0.2;

subplot(121) 

plot11=plot(timeplot,ave_k);
title('Optimal Information Capacity');
xlabel('time');
ylabel('Attention');
legend('Total Attention');
set(plot11,'Marker','.')
ylim([min(plotk),max(plotk)]);
patch('YData',plotk(1:end-1),'XData',timeplot,'Facealpha',0.5,'EdgeColor',[0.831372549019608 0.815686274509804 0.784313725490196],'FaceColor',[0.831372549019608 0.815686274509804 0.784313725490196]);

subplot(122) 

plot12=plot(timeplot,ave_ka,timeplot,ave_ks);
title('Optimal Attention Allocation');
xlabel('time');
ylabel('Attention');
legend('Attention to Aggregate Conditions','Attention to Idiosyncratic Conditions');
set(plot12(1),'Marker','.');
set(plot12(2),'Marker','.','Color',[1,0,0]);
ylim([min(plotkas),max(plotkas)]);
patch('YData',plotkas(1:end-1),'XData',timeplot,'Facealpha',0.5,'EdgeColor',[0.831372549019608 0.815686274509804 0.784313725490196],'FaceColor',[0.831372549019608 0.815686274509804 0.784313725490196]);
   
figure() 

plotmu(recindexplot)= 1;
plotmu(expindexplot)= 0;

plot2=plot(timeplot,ave_mupost);
title('Posterior Probability (sigma = sigma_H)');
xlabel('Time');
ylabel('Probability');
ylim([0 1]);
patch('YData',plotmu(1:end-1),'XData',timeplot,'Facealpha',0.5,'FaceColor',[0.831372549019608 0.815686274509804 0.784313725490196],'EdgeColor',[0.831372549019608 0.815686274509804 0.784313725490196]);


save('combinesimul.mat');
    

