function [c,d]=opsig(kappa1,a,L,m,options1)
    
sigma = fsolve(@IIDsignals,a(1),options1,a,kappa1);
    if sigma < 0; sigma = -sigma; end;
    M = zeros(m,m-1+L); N = zeros(m,m-1+L);
    for j = 1:m;
        M(j,j:j-1+length(a)) = a'; 
        N(j,j:j-1+length(sigma)) = sigma'; 
    end;
    lambda_vec = [a; zeros(m-1+L-length(a),1)];
    c = (((M*M'+N*N')\(M*lambda_vec))'*M)'; 
    d = (((M*M'+N*N')\(M*lambda_vec))'*N)'; 
    c = c(1:L); 
    d = d(1:L); 