function [c,d,f,g]=signalsolve(kappa1,kappa2,a,b,options1,L,m)
    
sigma = fsolve(@IIDsignals,a(1),options1,a,kappa1);
    if sigma < 0; sigma = -sigma; end;
    M = zeros(m,m-1+L); N = zeros(m,m-1+L);
    for j = 1:m;
        M(j,j:j-1+length(a)) = a'; 
        N(j,j:j-1+length(sigma)) = sigma'; 
    end;
    lambda_vec = [a; zeros(m-1+L-length(a),1)];
    c = (((M*M'+N*N')\(M*lambda_vec))'*M)'; 
    d = (((M*M'+N*N')\(M*lambda_vec))'*N)'; 
    c = c(1:L); 
    d= d(1:L); 
    
    sigma = fsolve(@IIDsignals,b(1),options1,b,kappa2);
    if sigma < 0; sigma = -sigma; end;
    M = zeros(m,m-1+L); N = zeros(m,m-1+L);
    for j = 1:m;
        M(j,j:j-1+length(b)) = b'; 
        N(j,j:j-1+length(sigma)) = sigma'; 
    end;
    lambda_vec = [b; zeros(m-1+L-length(b),1)];
    f = (((M*M'+N*N')\(M*lambda_vec))'*M)'; 
    g = (((M*M'+N*N')\(M*lambda_vec))'*N)'; 
    f = f(1:L); 
    g = g(1:L); 
    
